package it.micegroup.gestioneferie.pianificazioneferie.assembler;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;
import org.springframework.hateoas.CollectionModel;
import org.springframework.hateoas.Link;
import org.springframework.stereotype.Component;

import it.micegroup.gestioneferie.libs.assembler.BaseModelAssembler;
import it.micegroup.gestioneferie.pianificazioneferie.controller.DsollecitiPfController;
import it.micegroup.gestioneferie.pianificazioneferie.dto.DsollecitiPfDto;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DsollecitiPf;

import it.micegroup.gestioneferie.pianificazioneferie.controller.DrichAdesionePfController;

@Component
public class DsollecitiPfModelAssembler
		extends BaseModelAssembler<DsollecitiPf, DsollecitiPfDto, DsollecitiPfController> {

	@Override
	public DsollecitiPfDto toModel(DsollecitiPf dsollecitiPf) {
		DsollecitiPfDto dsollecitiPfDto = map(dsollecitiPf, DsollecitiPfDto.class, DsollecitiPfController.class);

		// SELF LINK
		Link selfLink = convert(
				linkTo(methodOn(DsollecitiPfController.class).getByObjectKey(dsollecitiPf.getObjectKey()))
						.withSelfRel());
		dsollecitiPfDto.add(selfLink);

		// PARENT LINKS
		if (dsollecitiPf.getTheDrichAdesionePf() != null) {
			Link drichAdesionePfLink = convert(linkTo(methodOn(DrichAdesionePfController.class)
					.getByObjectKey(dsollecitiPf.getTheDrichAdesionePfObjectKey())).withRel("theDrichAdesionePf"));
			dsollecitiPfDto.add(drichAdesionePfLink);
		}

		// CHILDREN LINKS

		// PARENTS LINKS FOR IMPORTED MS

		// CHILDREN LINKS FOR IMPORTED MS

		return dsollecitiPfDto;

	}

	@Override
	public CollectionModel<DsollecitiPfDto> toCollectionModel(Iterable<? extends DsollecitiPf> entities) {
		CollectionModel<DsollecitiPfDto> collectionEntities = super.toCollectionModel(entities);
		// collectionEntities.add(linkTo(methodOn(OrdineController.class).findPaginated(null,
		// null)).withSelfRel());

		return collectionEntities;
	}

}

